2004-12-19 Euan MacGregor (zx64)
  * internal: Fixed stupid thinko in Selection code (transposed two function
    names).
  * sound: Handled SDL_mixer failing to initialise.
  * sound: Removed SoundError entirely.
  * internal: Assert positive refcount in UnitOrStructure::unrefer
  * internal: More refactorring of Selection:
    - Removed getRandomStructure (only one thing was using it and that was
      rewritten)
    - purgeUnit and purgeStructure replaced by a single purge function that
      forwards to a templated function.
  * internal: Reorderred first two parameters of IMADecode and WSADPCM_Decode to
    have same orderring as memcpy et al.
  * build: Improve posix_snapshot script.

2004-12-19 Thomas Johansson (prencher)
  * general: Removed specific support for MSVC 6 (its crap). People should use
    MSVC 7.1 or MinGW on win32 instead.
  * build: Removed MSVC 6 build files.
  * sound: Added music playback to the new SoundEngine.
  * sound: Fixed bug with handling of the vector that contains the audio data,
    which resulted in no sound being played.
  * sound: Added new Decode and LoadSound API.
  * internal: Added #include <cassert> to unitorstructure.h.. tsk tsk zx64.

2004-12-18 Euan MacGregor (zx64)
  * build: Added flags for release build in comments, removed mix/tgz config
    fragments.
  * internal: SoundError now a derived class of std::runtime_error.
  * sound: Fixed some memory leaks in the new version of Decode (API was unclear
    about ownership semantics when creating chunks from existing data).

2004-12-17 Euan MacGregor (zx64)
  * build: Added a posix version of the snapshot script.

2004-12-17 Thomas Johansson (prencher)
  * build: Added a script to automate snapshot creation.

2004-12-16 Euan MacGregor (zx64)
  * internal: Initial refactorring of the Selection code.

2004-12-15 Thomas Johansson (prencher)
  * sound: Added completely new SoundEngine, with basic sound support. The new
    engine is based on SDL_mixer. While still lacking music playback and VQA,
    these will be added soon.
  * general: Reorganised the dir structure of the project a bit.
  * general: Added fancy icons, woot.
  * general: Fixed linebreaks in various files.
  * build: Another facelift for the MSVC 7.1 files.

2004-12-15 Euan MacGregor (zx64)
  * general: Removed tgz plugin.
  * general: Reintegrated mix plugin into the VFS.

2004-12-13 Euan MacGregor (zx64)
  * ui: Fixed some audio feedback inconsistencies with the buildqueue.

2004-12-09 Euan MacGregor (zx64)
  * internal: Fixed problem when building caused by MoneyCounter flooding
    eventqueue.

2004-12-07 Euan MacGregor (zx64)
  * vfs: Changed plugin code to use a more suitable extension for each OS.
  * vfs: Applied similar refactorring techniques previously used for tools on
    vfs plugins.

2004-12-06 Euan MacGregor (zx64)
  * tools: Refactorred most of the tools Makefile into a common file to include.
  * internal: Fixed some errors found by additional warnings.
  * vfs: Fixed a 32bit-ism.

2004-12-05 Thomas Johansson (prencher)
  * overall: Removed old netcode, as it was just polluting the codebase, and
    not being used.
  * overall: Removed code (and build files) for BeOS, MacOS classic and HPUX.
    If any developer(s) for these platforms are interested in keeping a port
    alive, you can contact us through the mailing lists.

2004-09-16 Thomas Johansson (prencher)
  * internal: Santised some type code in the buildqueue.

2004-09-10 Euan MacGregor (zx64)
  * gameplay: Added grenades (doesn't arc or animate yet).

2004-09-09 Euan MacGregor (zx64)
  * tools: Fixed log filenames.

2004-09-08 Euan MacGregor (zx64)
  * gameplay: Added more costs for TD units and structures.

2004-09-06 Euan MacGregor (zx64)
  * ui: Tweaked logic to determine whether to display the sidebar.
  * sound: Added audio feedback for starting, pausing and cancelling
    construction.

2004-09-03 Euan MacGregor (zx64)
  * internal: Moved the Player bits from playerpool.(cpp|h) into player.(cpp|h).
  * internal: Moved ConStatus into common.h.
  * sound: Player now gets audio feedback from money being credited and debited.

2004-09-01 Euan MacGregor (zx64)
  * internal: Made Sidebar::drawButton a bit cleaner/clearer.

2004-08-31 Euan MacGregor (zx64)
  * gameplay: Added some costs.

2004-08-30 Euan MacGregor (zx64)
  * gameplay: Fixed "losing" a unit when clicking on the sidebar to
    produce a unit that was waiting for an exit position (and had been
    cleared).
  * ui: Fixed sidebar not updating when placing a wall.
  * internal: Removed direct calls to the sidebar from the buildqueue.
  * ui: Fixed right clicking on scroll buttons not resetting the
    depressed state after releasing the mouse button.
  * ui: Fixed drawing the clock when in an invalid state.

2004-08-29 Euan MacGregor (zx64)
  * gfx: Fixed max steps in RA clock animation.
  * ui: Don't draw the clock when it wouldn't have changed the  appearance.
  * gameplay: Fixed queue not resuming when cancelling the item being built
    even though there are other items queued.

2004-08-28 Euan MacGregor (zx64)
  * gameplay: Fixed structure placement for structures with non-blocked areas.
  * gameplay: Fixed building not stopping when paused.
  * internal: Rewrote sidebar status reporting to use precalculated tables.

2004-08-27 Euan MacGregor (zx64)
  * gameplay: Finally merged (a heavily modified version of) Andreas Koop's
    buildqueue patch.

2004-08-25 Euan MacGregor (zx64)
  * internal: Renumberred unittypes so that zero is invalid.
  * internal: Changed createmode related code in input/sidebar to use an
    enumerated value.
  * internal: Fixed integer overflow in dispatcher.
  * internal: Added isStructure to UnitOrStructureType as that's faster than a
    dynamic_cast for those cases when you do need to know the underlying type.
  * internal: Merged unit spawning from buildqueue tree.
  * internal: Merged changes to sidebar button code from buildqueue tree.

2004-08-08 Euan MacGregor (zx64)
  * internal: Abstracted loading inifiles into a map in the p namespace to avoid
  redundant loads.

2004-07-25 Thomas Johansson (prencher)
  * documentation: Updated CODING_STYLE to be alot more specific about our
    coding conventions. Any contributors should read and follow this if they
    wish to participate.

2004-07-23 Thomas Johansson (prencher)
  * documentation: Renamed freecnc-doxygen.conf to Doxyfile, updated makefile
    doxygen target to use it, and updated the doxygen config a bit.

2004-07-20 Euan MacGregor (zx64)
  * internal: Update FreeBSD config files to address link issue.

2004-07-19 Euan MacGregor (zx64)
  * internal: Cleaned up Font to use std::vector et al.

2004-07-17 Euan MacGregor (zx64)
  * internal: Updated mingw config files.

2004-07-13 Euan MacGregor (zx64)
  * general: Started moving configuration files into per-game subdirectories.

2004-07-11 Euan MacGregor (zx64)
  * internal: Rewrote determineBinaryPath to use std::string.
  * internal: Added a temporary way of having seperate config files for TD and
    RA.  Added RA config files for units and structures.
  * general: Restructured tree to have a data directory which will
    contain the ini files, the mix files and in game scripts.
  * general: Moved contents of conf to data/settings.
  * internal: Fixed running freecnc when not inside the source directory.

2004-07-11 Thomas Johansson (prencher)
  * general: cleaned up freecnc.cpp a bit, removed freecnc.h
  * build: updated the vfs_* msvc71 projects for new plugin structure.

2004-07-10 Euan MacGregor (zx64)
  * general: Moved vfs plugins out of src/vfs and into the new plugins
    hierarchy.
  * general: Changed the logo to something a bit more appropriate.

2004-07-10 Thomas Johansson (prencher)
  * general: Added lua into the tree, lua will be used for our scripting.

2004-07-06 Thomas Johansson (prencher)
  * build: MSVC 6 files moved to projects/msvc60, mk/* removed.

2004-07-06 Thomas Johansson (prencher)
  * build: Added projects/, and MSVC 7.1 build files in projects/msvc71.
    MSVC 6 files will also be moved to projects/, and mk/ will be removed.
  * general: Updated alot of source files so freecnc now builds in MSVC 7.1,
    although still with alot of warnings. Cleaned up a few of before mentioned
    warnings while at it.
 
2004-07-03 Euan MacGregor (zx64)
  * internal: Removed "portable snprintf", converted some of the affected code
    to std::string.

2004-06-17 Euan MacGregor (zx64)
  * internal: Fixed horrible bug-caused-by-typo in unitandstructurepool found
    by GCC 3.5.
  * internal: Moved all ExtPriv stuff out of externalvfs.h into the .cpp file.

2004-06-03 Euan MacGregor (zx64)
  * internal: Moved some badly placed inline functions to a better place.
  * internal: Renamed "fullscreenMovies" to "scaleMovies" in freecnc.ini.

2004-05-26 Euan MacGregor (zx64)
  * internal: Minor code cleanup in the VFS plugins.
  * internal: Rewrote MIXFile header parsing code to remove union trick: it's
    a (minor) headache to port, so will explicitly calculate flags on all platforms.

2004-05-17 Euan MacGregor (zx64)
  * internal: Adjusted alignement of mix_header's struct t, working towards
    fixing the endian bugs in this code.

2004-04-12 Euan MacGregor (zx64)
  * internal: Moved all of the dispatcher inside a namespace as part of
    adopting a similar approach elsewhere in the tree.
  * internal: Added buildqueue API to dispatcher.
  * ui: Unit placement code now adds infantry to existing infantry groups.

2004-04-10 Euan MacGregor (zx64)
  * internal: Phixed phoney spelling (.PHONY not .PHONEY, even if both are in
    the dictionary).
  * internal: Moved makedepend generated bits into seperate files.  They'll
    still go in CVS as not all platforms have makedepend.
  * internal: Fixed silly mistake in the depend rule in src's Makefile.
  * sidebar: Fixed a surface leak in fallback.
  * sidebar: Removed unnecessary instances of unit/structure ini.
  * sidebar: Changed behaviour of radar anim to not reload the SHP on each
    frame. (Ugh).

2004-04-03 Euan MacGregor (zx64)
  * internal: Fixed directories under Win32.

2004-03-21 Euan MacGregor (zx64)
  * internal: More cleanup in UnitAndStructurePool.

2004-03-20 Euan MacGregor (zx64)
    (The "I'm baaack" commit)
  * internal: Assorted cleanups of Player and PlayerPool.
  * admin: Updated the syncmail and ciabot scripts.
  * internal: Added some (commented out) ifdefs for (compile time) enforcement
    of the client/server split.  They'll be enabled when they won't break
    things.

2003-12-28 Euan MacGregor (zx64)
  * internal: Removed the superweapons hacks: I'd rather see this done
    properly.
  * internal: Removed the "deploywith" part of the new unit placement code.
  * internal: Split "aircraft" unit type type into "plane" and "helicopter"
    types: they move, attack and land differently.
  * internal: Fixed primary building only working between groups of structures
    of the same type.
  * internal: Enabled new unit placement code (was previously ifdef'd).

2003-12-27 Euan MacGregor (zx64)
  * internal: Removed cost routines from sidebar as they aren't designed
    right: money should be deducted in small chunks as the build progresses.
    Also, the routines got in the way of debugging far too often.

2003-12-26 Jonas Jermann (g0th)
  * gameplay: New unit placement code: now places units nearby the primary
    building.
  * ui: Added more superweapons to the existing hack.
  * gfx: Changed the unit animations to have a variable end point in the loop.

2003-12-22 Euan MacGregor (zx64)
  * internal: Added internal.ini, moved buildable_ratio from freecnc.ini to
    there, added buildable_ratio as well.  Also contains further information to
    be used by the new sidebar layout code.

2003-12-21 Euan MacGregor (zx64)
  * internal: Formatting and some minor restructuring of shpimage.cpp.

2003-12-18 Euan MacGregor (zx64)
  * internal: Formatting and other minor layout tweaks to the sidebar code.

2003-12-15 Euan MacGregor (zx64)
  * internal: Changed INIFile's constructor to throw a runtime_error exception
    instead of int.  Wrapped the creation of the FreeCNC class inside a
    try/catch for this exception so some error handling code in can be remove
    elsewhere.
  * internal: Done the same to Font.
  * internal: Added ui.ini, but nothing that uses it at the moment.

2003-12-06 Euan MacGregor (zx64)
  * internal: Added "fenc" to ui/input.cpp's list of walls.
  * internal: Merged a patch that fixes a few issues when building with MSVC6.

2003-11-16 Euan MacGregor (zx64)
  * internal: Merged (a modified version of) Tim's (via g0th) work on
    OVERLAYPACK support and cleaned up a few bits in loadmap.cpp.
  * internal: Split resources away from normal overlays to make changing the
    amount of resource on a tile easier.

2003-11-15 Euan MacGregor (zx64)
  * build: Added a new DSP file to the MSVC build directory.

2003-11-03 Euan MacGregor (zx64)
  * internal: More template data for RA from g0th.

2003-10-13 Euan MacGregor (zx64)
  * vfs: Fixed an oops that was causing a build problem on RH9.

2003-09-28 Bernd Ritter (comrad)
  * ui: Sidebar now checks if Player has sufficient funds. Press
    m-Key for money cheat

2003-09-24 Euan MacGregor (zx64)
  * internal: Cleaned up some sections of the sidebar to use the correct
    enums.

2003-09-23 Euan MacGregor (zx64)
  * vfs: Added some more case munging logic, moved some char* to
    std::string.

2003-09-20 Euan MacGregor (zx64)
  * ui: Tweaked scrolling logic to make it use the cursor indicating the
    actual direction of scrolling.

2003-09-16 Euan MacGregor (zx64)
  * internal: Misc. cleanups of input.(cpp|h).

2003-09-08 Euan MacGregor (zx64)
  * video: Patch from SF fixes fullscreen radar crash.  Thanks again
    and<dot>koop<at>web<dot>de.
  * internal: New build system has been fully merged.

2003-09-05 Euan MacGregor (zx64)
  * config: Fullscreen can now be configured via freecnc.ini.

2003-09-03 Euan MacGregor (zx64)
  * internal: Started merging new build system.

2003-07-28 Euan MacGregor (zx64)
  * internal: Added an optional prefix to readIndexedKeyValue.
  * internal: Rewrote various sections that used sprintf and
    INIFile::readString to use readIndexedKeyValue with a prefix.

2003-07-27 Euan MacGregor (zx64)
  * VFS: Fixed a problem where files in the current directory weren't being
    found.

2003-07-26 Euan MacGregor (zx64)
  * internal: Fixed the linenum decoding algorithm for RA so more of the map
    is loaded properly.

2003-07-24 Euan MacGregor (zx64)
  * internal: Added a custom terminate handler to wrap SDL_Quit around
    either std::abort or GCC's enhanced terminate hander.
  * internal: Added a wrapper around an internal libc call to force
    memory deallocation to cut down on false leak reportings.
  * internal: Added a check for an environment variable that changes the
    behaviour of libstdc++'s allocators to cut down on false leak
    reportings.

2003-07-22 Euan MacGregor (zx64)
  * general: Added some hacks to allow FreeCNC to work with the Red Alert demo
    without needing updatec.mix from Tiberium Dawn.

2003-07-21 Euan MacGregor (zx64)
  * general: Added a contributed ratemplates.ini for much better Red Alert
    support.  Thanks and<dot>koop<at>web<dot>de.
  * internal: Cleaned up usage of namespace std.
  * internal: Fixed an ordering problem in INIFile::readKeyValue.

2003-07-19 Euan MacGregor (zx64)
  * internal: Rewrote sidebar icon loader to use imagecache.
  * internal: Made the SHP error messages more useful.

2003-07-16 Euan MacGregor (zx64)
  * gameplay: Made proximity checking more flexible: will allow placing
    something if most of the building is in range.
  * internal: Non-pathfinder code now uses something other than getCost to
    determine whether terrain is buildable.

2003-07-10 Euan MacGregor (zx64)
  * internal: Removed an unneeded block of code from str(n)casecmp.
  * internal: Restructured the image cache to let the STL do more of the
    work.
  * internal: Changed checks against container.size()==0 to container.empty().
  * internal: Found and removed some more unneeded checks against NULL.
  * internal: Cleaned up the return values in strcase.cpp.

2003-07-09 Euan MacGregor (zx64)
  * internal: Changed logger to create the log in the current directory
    instead of where the binary is.
  * internal: Renamed "decode2" to "decode20".
  * VFS: VFS now falls back to trying current directory and the
    directory containting the binary if files.ini is missing.
  * internal: Fixed some unhandled exceptions.

2003-06-19 Bernd Ritter (comrad)
  * internal: Added OpenBSD/FreeBSD Support to the makefile and warnings
    to use gmake instead of make

2003-06-18 Euan MacGregor (zx64)
  * internal: Moved parsing of art.ini out of StructureType as we've been
    reading the whole thing in each time.
  * internal: Code cleanup:
    - loadmap.cpp: removed dead code
    - vfs.cpp: rewrote some loops for readability
    - unitandstructurepool.cpp: changed unitandstructmat to a vector<Uint32>
    - cursorpool.cpp: updated to use logger and exceptions
    - wsa.cpp: updated to use logger
    - snprintf.cpp, snprintf.h, common.h: tweaks to make tree buildable with
      more strict flags.

2003-06-17 Euan MacGregor (zx64)
  * internal: Added commit tracking notification via CIABot.
  * internal: Reorderred includes.
  * internal: Removed some unneeded checks against NULL.

2003-05-11 Bernd Ritter (comrad)
  * ui: Added Niksies Cocoa-Launcher. All launchers are now
    placed in tools/launcher/.

2003-04-11 Euan MacGregor (zx64)
  * internal: Added the framework part of the dispatcher.
  * internal: Const correctness for DLLibrary.
  * internal: Merged Tim's AI plugin loader.

2003-04-09 Euan MacGregor (zx64)
  * ui: Really fixed placement bug.
  * gfx: Tweaked healthbar size so full health on infantry is symmetrical.
  * gfx: Added a hack to the cursor loader that changes 0x0c to 0x9a so
    cursors have a drop shadow, even if it isn't the right shade.

2003-04-08 Euan MacGregor (zx64)
  * internal: Switched to using std::min and std::max over macros.
  * ui: Fixed an off-by-one bug in the placement logic that prevented you
    from placing structures on the bottom and right edges.

2003-04-07 Bernd Ritter (comrad)
  * ui: Added Version 0.9.5 of the TCL/TK Launcher, which now can
    select and run individual missions.

2003-04-06 Euan MacGregor (zx64)
  * internal: More cleanup: started identifying parts of the CnCMap class
    to go in the client or server versions, changed the remaining #defines in
    ccmap.h to static consts.
  * internal: Fixed a bug in the animation code that plays a sound when the
    map is loading if a building is created damaged.
  * vfs: External vfs is more case insensitive (will try all upper and all
    lower versions of filename).

2003-04-02 Bernd Ritter (comrad)
  * internal: Support for Solaris and Irix compilation (based on
    Thomas Dettbarn's tdettbar<at>TechFak<dot>Uni-Bielefeld<dot>DE mail).
2003-04-02 Euan MacGregor (zx64)
  * internal: Large restructuring to clean up the interdependencies.
  * internal: More general cleanup.

2003-04-01 Euan MacGregor (zx64)
  * internal: Renamed endian.h to fcnc_endian.h.
  * internal: Cleaned up a few things left over from the memtrack purge.
  * internal: Cleaned up some of the usage of exceptions.
  * internal: Renamed map.h to ccmap.h (just in case).

2003-03-29 Euan MacGregor (zx64)
  * internal: Moved SDLNet_Init to the static initialiser so things don't
    break if the class gets constructed more than once.  Added a wrapper
    around SDLNet_Quit.
  * graphics: Poked some of the 8 bit mode code, still broken though.

2003-03-28 Euan MacGregor (zx64)
  * win32: Workaround for some breaks on Win32: Windowed mode is now default.

2003-03-26 Euan MacGregor (zx64)
  * internal: Removed rest of existing AI code since it isn't going anywhere.

2003-03-25 Euan MacGregor (zx64)
  * internal: Cleaned up the network code.
  * internal: Added a portable implementation of snprintf by Mark Martinec.

2003-03-21 Euan MacGregor (zx64)
  * VFS: Downgraded severity of message when failing to find a required
    mixfile for game, since it seems to confuse more than help.
  * internal: Removed return statements from some void functions (was
    returning void, but MSVC choked).

2003-03-05 Euan MacGregor (zx64)
  * internal: Fixed a crash bug when starting with files.ini missing.
  * internal: Fixed a bug in the deploy code that broke setting health
    when health/maxhealth ratio was less than one.

2003-02-22 Euan MacGregor (zx64)
  * internal: Code cleanup: removed the memtracker and the timeline (neither
    were used).  All C includes have been changed to use C++ style naming
    schemes.

2003-02-17 Euan MacGregor (zx64)
  * internal: Tightened up some of the Makefile targets to eliminate useless
    relinkings.
  * internal: Changed L2Overlay back into a struct: no benefit from using a
    get/set approach in this case.

2003-02-07 Euan MacGregor (zx64)
  * internal: Possible workaround for slight difference in how YellowDog
    handles passing va_lists to functions.

2003-02-04 Euan MacGregor (zx64)
  * vfs: Added a logger->note to the game loader so people looking
    through the log can see why the ERRORs occur.

2002-12-26 Euan MacGregor (zx64)
  * vfs: Added some functions to the VFS to find the first file that exists
    in a list passed either using va_args or by the return type of splitList.
  * internal: Changed the sidebar to use this instead of nesting try/catch.

2002-12-24 Euan MacGregor (zx64)
  * internal: Fixed a problem with getTypeByName not giving useful data.

2002-12-23 Euan MacGregor (zx64)
  * ui: Added a key binding (g) to toggle mouse grab.
  * internal: Made the map loader be a bit more useful in a specific error (no
    entry in art.ini for a TERRAIN item)
  * internal: Updated the build system so that tools are now also built.
  * internal: Added getTypeByName for getting a UnitOrStructureType*.
  * internal: Changed behaviour of the weapons factory door controller.

2002-12-20 Bernd Ritter (comrad)
  * ui: Update of the Tcl/tk Launchertool. Now recognises the
    used MIX-files and shows up a list with the possible missions.
2002-12-20 Euan MacGregor (zx64)
  * internal: Standardised on toupper over tolower when destroying case.

2002-12-18 Euan MacGregor (zx64)
  * internal: Standardised on USPool over UASP

2002-12-08 Euan MacGregor (zx64)
  * internal: Tweaked unit animation code, seems a bit more stable.

2002-11-28 Euan MacGregor (zx64)
  * graphics: Radar now draws the shapes of partially not-blocked structures.

2002-11-26 Euan MacGregor (zx64)
  * internal: Fixed a crash bug found when using "skirmish" mode.
    Changed graphics engine's map variable to ccmap so that gdb works.
    Player class has a bit more sanity checking.
    Fixed a crash bug when starting up with invalid args.
  * graphics: Prelookup the radar colouring at the start to save a bit
    of time when rendering
2002-11-26 Bernd Ritter (comrad)
  * ui: Initial commit of a tcl/tk based launcher.

2002-11-25 Euan MacGregor (zx64)
  * graphics: Initial commit of radar code.  Still a few things left to do,
    such as rendering walls in the minimap and drawing partially not-blocked
    structures properly.

2002-11-24 Euan MacGregor (zx64)
  * graphics: Fixed a wrong value in the turquoise palette which makes
    it look much nicer.

2002-11-22 Euan MacGregor (zx64)
  * internal: Map loader now uses the initial rotation and health values
    from the map.

2002-11-05 Euan MacGregor (zx64)
  * gameplay: Added fuel to projectiles, projectiles can now be
    restricted to moving for a certain number of ticks before being
    removed.  "Seekfuel" is how many ticks a heatseeking missile can
    change heading before reverting to a normal missle.
  * internal: Moved some map data to an external struct.  Fixed small
    leak in logger.
  * ui: Map names can now be longer that eight chars long.

2002-09-30 Euan MacGregor (zx64)
  * VFS: Added write support to the VFS (external files only).

2002-09-24 Euan MacGregor (zx64)
  * internal: Gold/DOS sidebar checking improvements.
  * gfx: DOS edition sidebar now uses the player's structure palette for the
    structure icons.

2002-09-21 Euan MacGregor (zx64)
  * internal: Player class should use less memory (changed some bool*
    to std::vector<bool>, and some Uint16* to Uint8*).

2002-09-19 Euan MacGregor (zx64)
  * internal: Added const flags to various functions in Unit,
    Structure and UnitOrStructure.
    unitnum and structnum are now Uint32.

2002-09-18 Euan MacGregor (zx64)
  * internal: Removed a non helpful check from the event queue.
    Changed Unit::getUnitnum() and Structure::getStructnum()
    to use the same name: getNum().

2002-09-03 Euan MacGregor (zx64)
  * internal: Merged changes from "Caz" to fix BeOS support

2002-09-01 Euan MacGregor (zx64)
  * internal: Moved determineBinaryLocation to common.cpp so that it
    can be used with the tools.
  * shpview: Compile fix that uses determineBinaryLocation.
  * audplay: Same fix.
  * tmpinied: Updated to plugin based VFS.
  * internal: New makefile system.  Should make building easier as no
    editing is needed.
  * gameplay: Fixed a crash bug with the demo on higher maps.

2002-08-29 Euan MacGregor (zx64)
  * UI: If the mouse is inside a cell that has enemy infantry
    inside, but isn't positioned on an enemy unit, the code will
    pick the nearest.

2002-08-24 Euan MacGregor (zx64)
  * internal: OSX fixes.

2002-08-19 Tim Johansson (Tim^)
  * gfx: Fixed a map centring problem (e.g. SCB01EA at 800x600)

2002-08-18 Tim Johansson (Tim^)
  * gameplay: Cleaned up and optimized the pathfinder.
2002-08-18 Euan MacGregor (zx64)
  * gfx: Sidebar now renders the type name of missing icons.
  * gameplay: Cleaned up unit animation code somewhat.

2002-08-16 Tim Johansson (Tim^)
  * gfx: Fixed some drawing bugs in fog of war smoothing.

2002-08-15 Tim Johansson (Tim^)
  * gfx: Fixed some rendering bugs in the healthbars: no right border
    when on 100% health and flooding when vehicles moved on screen
    from the left.
  * gfx: Added smooth edges on fog of war.
2002-08-15 Euan MacGregor (zx64)
  * ui: Right click drag scrolling now requires movement of 10 pixels.

2002-08-14 Euan MacGregor (zx64)
  * ui/gameplay:  User can disable prerequisites with the 'b' key.
  * gameplay: Really fixed bug in targeting structures.

2002-08-12 Euan MacGregor (zx64)
  * ui: An appropriate talkback is played when restoring a selection.
  * gameplay: Fixed a bug in the code to find the nearest cell of a structure.
  * ui: Added mouse wheel scrolling of the sidebar.

2002-08-11 Tim Johansson (Tim^)
  * gfx: fixed a bug which clipped the sidebar.
  * internal: Some compile fixes for win32.
  * gfx: Made the map centered if it's small enough to fit on the screen.
  * gfx: Fixed a crash bug in interlaced scaling.
  * ui: Fixed the setting of valid scroll directions.

2002-08-08 Tim Johansson (Tim^)
  * gfx: Added a drawLine function which will be used for obelisk and
    maybe targeting lines.
  * gfx: Fixed loading of startpos for map.
  * gfx: Rewrote the scrolling code to scroll pixel by pixel instead of
    tile by tile. This also removed the black border around the map.
  * internal: Fixed MacOSX dynamic loading code.

2002-08-07 Tim Johansson (Tim^)
  * gfx: Rewrote the scaling code.
2002-08-07 Euan MacGregor (zx64)
  * ui: Now dumps some stats to the logfile (and stdout if not on
    win32): time spent playing and kills/losses for each side.
  * ui: Right click dragging scrolls the map.

2002-08-06 Euan MacGregor (zx64)
  * internal: Updated talkback parser for new inifile code, also
    pooled talkbacks to result in significant savings in
    memory usage.

2002-08-05 Tim Johansson (Tim^)
  * internal: Rewrote the inifile parser. Now loads all values to memory
    which speed things up a lot.
  * gameplay: Made the pathfinder take fog of war into consideration.
  * internal: Changed the format of the required/optional files in files.ini

2002-08-04 Tim Johansson (Tim^)
  * internal: Fixed a possible race condition in the action event queue.
  * internal: A temporary fix for some dynamic loaders.
  * internal: Added a wrapper class for SDL_net.
  * internal: Added functions to find the directory containing the binary and
    use that for relative paths.
2002-08-04 Euan MacGregor (zx64)
  * internal: Fixed some warnings that occur when building optimised
    builds.

2002-08-02 The FreeCNC Team
  * release: 0.2.0
2002-08-02 Tim Johansson (Tim^)
  * gfx: Fixed a bug with the screen clearing code which made
    the screen flicker sometimes on win32 and possibly other
    platforms.
2002-08-02 Euan MacGregor (zx64)
  * ui: Fixed problem on levels where no units or structures are
    provided: you aren't able to see where you're placing the MCV
    and you aren't able to place the MCV without using the debug
    keys.  Behaviour now is to reveal the whole map and allow
    building anywhere, then revert to requring proximity once the
    MCV is placed (can still use 'c' to disable proximity checks).

2002-08-01 Tim Johansson (Tim^)
  * gfx: Fixed a bug where the healthbar for infantry was not clipped.
  * gfx: Fixed a bug where the minimap renderer was writing beyond the
    boundary of the pixels array of the destination surface.
  * gfx: Fixed a memleak in the video scaler.

2002-07-31 Euan MacGregor (zx64)
  * docs: Further updates.

2002-07-29 Euan MacGregor (zx64)
  * ui:  Made scroll speed configurable.
  * gameplay: Fixed a bug where the cost and armour values for
    walls were not being read.
  * internal: Fixed a bug in the one-on-one code in ai.cpp (would
    write beyond the end an array).

2002-07-28 Euan MacGregor (zx64)
  * music:  Added a NONE playlist, fixed a bug in the playlist
            selection code.

2002-07-26 Euan MacGregor (zx64)
  * gfx: Fixed a bug with the colourisation of the NOD MCV.

2002-07-23 Tim Johansson (Tim^)
  * internal: Fixed win32 compability and removed delete for const char*

2002-07-18 Euan MacGregor (zx64)
  * internal: Fixed some bugs found by valgrind.

2002-07-16 Euan MacGregor (zx64)
  * patches: Applied Matze's patch fixing some char* expresions
    that should be const char*.

2002-07-15 Euan MacGregor (zx64)
  * gameplay: Fixed a bug in the deploy checks, thanks to "r00t" for
    finding that.

2002-07-10 Euan MacGregor (zx64)
  * gameplay: Added proper building placement, use 'c' to revert
    to previous behaviour.

2002-06-26 Euan MacGregor (zx64)
  * gameplay: Units and structures now should attack the nearest
    part of a structure.

2002-06-17 Euan MacGregor (zx64)
  * AI: AI now works with more than one opponent.

2002-06-10 Euan MacGregor (zx64)
  * gfx: Extended L2Overlay rendering to support multiple images per
    L2overlay.

2002-06-08 Kareem Dana (kareemy)
  * gfx: Added initial support for CPS Images.

2002-06-04 Euan MacGregor (zx64)
  * gfx: Fixed a problem with certain cursors not being coloured
    properly.

2002-06-03 Euan MacGregor (zx64)
  * internal: Started moving some common code into UnitOrStructure.

2002-06-01 Tim Johansson (Tim^)
  * general: Added a dll loader which doesn't require libtool.
    This is loosely based on the arianne code but heavily modified.
2002-06-01 Euan MacGregor (zx64)
  * audplay: Updated audplay for new VFS and logger class.

2002-05-30 Tim Johansson (Tim^)
  * general: Added a new plugin for the vfs. The plugin handles tgz
    files (gzipped tar files), and requires zlib.

2002-05-24 Tim Johansson (Tim^)
  * general: Added a plugin manager responisble for loading the VFS
    plugins as needed. Also fixed some minor issues with
    the new vfs code.

2002-05-23 Tim Johansson (Tim^)
  * general: Implemented a new VFS (Virtual File System) which is
    based on plugins.
  * internal: Fixed some warnings found by mingw

2002-05-23 Euan MacGregor (zx64)
  * audio:  One line fix to make audio work on OSX :)
  * general:  Merged debian stuff from Alfie.

2002-05-18 Tim Johansson (Tim^)
  * UI: Added a logger class which is to replace all printfs so
    everything is added to a logfile.
  * internal: Fixed a crash on exit while attacking and made some
    compile-fixes for win32

2002-05-16 Euan MacGregor (zx64)
  * UI, gameplay: Added start of passenger code.

2002-05-14 Tim Johansson (Tim^)
  * GFX: Added loading screen

2002-05-13 Tim Johansson (Tim^)
  * Gameplay, GFX: Added Fog of War code
  * internal: Minor fixes to movement and some compile-fixes for win32

2002-04-25 Euan MacGregor (zx64)
  * UI and gfx: When moving units, an animating pulse is drawn.
  * UI, playerpool and gfx: Primary building can be set, the
    appropriate pip is also drawn.

2002-04-23 Euan MacGregor (zx64)
  * internal: Moved some common types and constants to a new header.
  * UI: Fixed a bug with the selection box not being clipped at
    the tiled map edges.

2002-04-12 Euan MacGregor (zx64) and Bernd Ritter (comrad)
  * network: Client connects to server :-)
  * general: Code now requires SDL_net to compile.

2002-04-10 Euan MacGregor (zx64)
  * UI: Radar is now only available after building a comm. centre,
    and you lose that if all your comm. centres are destroyed.
  * internal: Memtracker compiles again.  Most memleaks fixed.

2002-04-08 Euan MacGregor (zx64)
  * general: Added a tech tree (e.g. need to build a barracks before
    you can build infantry).
  * UI: Bugfix to the sidebar (would draw incorrectly with the Gold
    edition if there were fewer valid icons than spaces).
  * gameplay: Free MCV if the map does not have any initial units
    or structures.

2002-04-02 Euan MacGregor (zx64)
  * general: More work on multiplayer/skirmish support:
    now have to specify how many players and which player
    is the local player.
  * args: Catches possible typos upon start up.

2002-03-24 Euan MacGregor (zx64)
  * playerpool: Initial work for multiplayer/skirmish support.
  * UI: 'a' toggles alliances (multiplayer/skirmish only).
  * playerpool: human player is now local player.
  * playerpool: multiplayer start locations are read in from map.
  
2002-03-23 Euan MacGregor (zx64)
  * video: NOD units now have different palette to the structures.
  * playerpool: No longer deletes defeated players.
    Used for tracking stats after mission has finished.
  * playerpool: Alliance information is now stored and understood.
  * INIFile: Added a stack to preserve file offsets and a function to
    separate comma separated lists.

2002-03-22 Euan MacGregor (zx64)
  * UI: Right-clicking cancels deploying.
  * general: Code now compiles with more strict options.
  * general: Error handling was improved.

2002-03-20 Euan MacGregor (zx64)
  * UASP: Added checks to createUnit and createStructure so that they
    would return immediately if the destination cell was already
    occupied.

2002-02-27  Sander van Geloven (Pander)
  * general: Initial ChangeLog release.
